#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_SouthSeaTreasureHuntEnterCFG.h"
std::auto_ptr<Fish_SouthSeaTreasureHuntEnterCFG> Fish_SouthSeaTreasureHuntEnterCFG::msSingleton(nullptr);

int Fish_SouthSeaTreasureHuntEnterCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_SouthSeaTreasureHuntEnterCFGData* Fish_SouthSeaTreasureHuntEnterCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_SouthSeaTreasureHuntEnterCFGData>& Fish_SouthSeaTreasureHuntEnterCFG::GetMapData()
{
	return mMapData;
}

void Fish_SouthSeaTreasureHuntEnterCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_SouthSeaTreasureHuntEnterCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_SouthSeaTreasureHuntEnterCFGData data;
		data.mID = element->IntAttribute("ID");
		{
			const char* Enter1 = element->Attribute("Enter1");
			std::vector<std::string> vecEnter1;
			boost::split(vecEnter1, Enter1, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecEnter1.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecEnter1[i].c_str(), &temp))
				{
					data.mEnter1.push_back(temp);
				}
			}
		}
		{
			const char* Enter2 = element->Attribute("Enter2");
			std::vector<std::string> vecEnter2;
			boost::split(vecEnter2, Enter2, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecEnter2.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecEnter2[i].c_str(), &temp))
				{
					data.mEnter2.push_back(temp);
				}
			}
		}
		{
			const char* Rewards = element->Attribute("Rewards");
			std::vector<std::string> vecRewards;
			boost::split(vecRewards, Rewards, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewards.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewards[i].c_str(), &temp))
				{
					data.mRewards.push_back(temp);
				}
			}
		}
		data.mName = element->Attribute("Name");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_SouthSeaTreasureHuntEnterCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_SouthSeaTreasureHuntEnterCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_SouthSeaTreasureHuntEnterCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_SouthSeaTreasureHuntEnterCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_SouthSeaTreasureHuntEnterCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readVectorInt(L, "Enter1", data.mEnter1);
		LuaCfgHelper::readVectorInt(L, "Enter2", data.mEnter2);
		LuaCfgHelper::readVectorInt(L, "Rewards", data.mRewards);
		LuaCfgHelper::readString(L, "Name", data.mName);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_SouthSeaTreasureHuntEnterCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_SouthSeaTreasureHuntEnterCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_SouthSeaTreasureHuntEnterCFG* Fish_SouthSeaTreasureHuntEnterCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_SouthSeaTreasureHuntEnterCFG());
	}
	return msSingleton.get();
}

void Fish_SouthSeaTreasureHuntEnterCFG::Release()
{
	msSingleton.reset(nullptr);
}
